--[[ <defaults>
	<seasonalGrowth>true</seasonalGrowth>
	<daysPerPeriod>3</daysPerPeriod>
	<fixedVisualMonth>false</fixedVisualMonth>
	<snow>true</snow>
	
	<cropDestruction>true</cropDestruction>
	<ploughing>true</ploughing>
	<fieldStone>true</fieldStone>
	<weeds>true</weeds>
	
	<dirt>normal</dirt>
	<autoStart>false</autoStart>
	<stopBraking>false</stopBraking>
	<trailerFillLimit>false</trailerFillLimit>
	<fuelUsage>high</fuelUsage>
	<ai>
		<fuel>false</fuel>
		<seeds>false</seeds>
		<fertilizer>false</fertilizer>
		<slurry>false</slurry>
		<manure>false</manure>
	</ai>

</defaults> ]]







RDM_careerDefaults = Mod:init()
RDM_careerDefaults.seasonalGrowth = 1
RDM_careerDefaults.daysPerPeriod = 3
RDM_careerDefaults.fixedVisualMonth = false
RDM_careerDefaults.snow = true
RDM_careerDefaults.cropDestruction = true
RDM_careerDefaults.ploughing = true
RDM_careerDefaults.fieldStone = true
RDM_careerDefaults.lime = true
RDM_careerDefaults.weeds = true
RDM_careerDefaults.dirt = 2
RDM_careerDefaults.autoStart = false
RDM_careerDefaults.stopBraking = false
RDM_careerDefaults.trailerFillLimit = false
RDM_careerDefaults.fuelUsage = 3
RDM_careerDefaults.aiFuel = false
RDM_careerDefaults.aiSeeds = false
RDM_careerDefaults.aiFertilizer = false
RDM_careerDefaults.aiSlurry = 1
RDM_careerDefaults.aiManure = 1
RDM_careerDefaults.initialDay = (RDM_careerDefaults.daysPerPeriod*5)+1 --16
RDM_careerDefaults.savedXMLFile = "modSettings/FS22_RDM_NewCareerDefaults/defaults.xml"



function RDM_careerDefaults:beforeStartMission()

	if g_currentMission.missionInfo.savegameDirectory ==nil then
		RDM_careerDefaults.createSchema()
		RDM_careerDefaults.readSavedXML()

		g_currentMission.missionInfo.plannedDaysPerPeriod = RDM_careerDefaults.daysPerPeriod

		g_currentMission:setSnowEnabled(RDM_careerDefaults.snow, true)
		--g_currentMission:setGrowthMode(RDM_careerDefaults.seasonalGrowth, true)
		g_currentMission:setFruitDestructionEnabled(RDM_careerDefaults.cropDestruction, true)
		g_currentMission:setPlowingRequiredEnabled(RDM_careerDefaults.ploughing, true)
		g_currentMission:setStonesEnabled(RDM_careerDefaults.fieldStone, true)
		g_currentMission:setLimeRequired(RDM_careerDefaults.lime, true)
		g_currentMission:setWeedsEnabled(RDM_careerDefaults.weeds, true)
		g_currentMission:setDirtInterval(RDM_careerDefaults.dirt, true)
		--g_currentMission:setFixedSeasonalVisuals(fixedSeasonalVisuals, true)
		g_currentMission:setAutomaticMotorStartEnabled(RDM_careerDefaults.autoStart, true)
		g_currentMission:setHelperBuyFuel(RDM_careerDefaults.aiFuel, true)
		g_currentMission:setHelperBuySeeds(RDM_careerDefaults.aiSeeds, true)
		g_currentMission:setHelperBuyFertilizer(RDM_careerDefaults.aiFertilizer, true)
		g_currentMission:setHelperSlurrySource(RDM_careerDefaults.aiSlurry, true)
		g_currentMission:setHelperManureSource(RDM_careerDefaults.aiManure, true)
		g_currentMission:setFuelUsage(RDM_careerDefaults.fuelUsage, true)
		g_currentMission:setStopAndGoBraking(RDM_careerDefaults.stopBraking, true)
		g_currentMission:setTrailerFillLimit(RDM_careerDefaults.trailerFillLimit, true)
	end

end

function RDM_careerDefaults:readSavedXML()

	local savedXMLFile = Utils.getFilename(RDM_careerDefaults.savedXMLFile, getUserProfileAppPath())
	--print(savedXMLFile)
	if fileExists(savedXMLFile) then
		local xmlFile = XMLFile.load("RDM_careerDefaults", savedXMLFile, RDM_careerDefaults.xmlSchema)

		
		local rootKey = "RDM_careerDefaults"
		RDM_careerDefaults.seasonalGrowth = xmlFile:getValue(rootKey .. ".seasonalGrowth", 0)
		RDM_careerDefaults.daysPerPeriod = xmlFile:getValue(rootKey .. ".daysPerPeriod", 0)
		--RDM_careerDefaults.fixedVisualMonth = xmlFile:getValue(rootKey .. ".fixedVisualMonth", 0)
		RDM_careerDefaults.snow = xmlFile:getValue(rootKey .. ".snow", 0)
		RDM_careerDefaults.cropDestruction = xmlFile:getValue(rootKey .. ".cropDestruction", 0)
		RDM_careerDefaults.ploughing = xmlFile:getValue(rootKey .. ".ploughing", 0)	
		RDM_careerDefaults.lime = xmlFile:getValue(rootKey .. ".ploughing", 0)	
		RDM_careerDefaults.fieldStone = xmlFile:getValue(rootKey .. ".fieldStone", 0)
		RDM_careerDefaults.weeds = xmlFile:getValue(rootKey .. ".weeds", 0)
		RDM_careerDefaults.dirt = xmlFile:getValue(rootKey .. ".dirt", 0)
		RDM_careerDefaults.autoStart = xmlFile:getValue(rootKey .. ".autoStart", 0)
		RDM_careerDefaults.stopBraking = xmlFile:getValue(rootKey .. ".stopBraking", 0)
		RDM_careerDefaults.trailerFillLimit = xmlFile:getValue(rootKey .. ".trailerFillLimit", 0)
		RDM_careerDefaults.fuelUsage = xmlFile:getValue(rootKey .. ".fuelUsage", 0)
		rootKey = rootKey..".ai"
		RDM_careerDefaults.aiFuel = xmlFile:getValue(rootKey .. ".fuel", 0)
		RDM_careerDefaults.aiSeeds = xmlFile:getValue(rootKey .. ".seeds", 0)
		RDM_careerDefaults.aiFertilizer = xmlFile:getValue(rootKey .. ".fertilizer", 0)
		RDM_careerDefaults.aiSlurry = xmlFile:getValue(rootKey .. ".slurry", 0)
		RDM_careerDefaults.aiManure = xmlFile:getValue(rootKey .. ".manure", 0)
		--RDM_careerDefaults.initialDay = xmlFile:getValue(key .. ".initialDay", 0) --16

		-- DebugUtil.printTableRecursively(RDM_careerDefaults,".",0,1)

	else
		local modSettingsFolder = g_currentModSettingsDirectory
		createFolder(modSettingsFolder)
		local xmlFile = XMLFile.create("RDM_careerDefaults", savedXMLFile, "RDM_careerDefaults",RDM_careerDefaults.xmlSchema)

        if xmlFile ~= nil then

			local rootKey = "RDM_careerDefaults"
			xmlFile:setFloat(rootKey..".seasonalGrowth", RDM_careerDefaults.seasonalGrowth)
			xmlFile:setFloat(rootKey..".daysPerPeriod", RDM_careerDefaults.daysPerPeriod)
			xmlFile:setBool(rootKey..".fixedVisualMonth", RDM_careerDefaults.fixedVisualMonth)
			xmlFile:setBool(rootKey..".snow", RDM_careerDefaults.snow)
			xmlFile:setBool(rootKey..".cropDestruction", RDM_careerDefaults.cropDestruction)
			xmlFile:setBool(rootKey..".ploughing", RDM_careerDefaults.ploughing)
			xmlFile:setBool(rootKey..".fieldStone", RDM_careerDefaults.fieldStone)
			xmlFile:setBool(rootKey..".weeds", RDM_careerDefaults.weeds)
			xmlFile:setBool(rootKey..".autoStart", RDM_careerDefaults.autoStart)
			xmlFile:setBool(rootKey..".stopBraking", RDM_careerDefaults.stopBraking)
			xmlFile:setBool(rootKey..".trailerFillLimit", RDM_careerDefaults.trailerFillLimit)
			xmlFile:setFloat(rootKey..".dirt", RDM_careerDefaults.dirt)
			xmlFile:setFloat(rootKey..".fuelUsage", RDM_careerDefaults.fuelUsage)
			rootKey = rootKey..".ai"
			xmlFile:setBool(rootKey..".fuel", RDM_careerDefaults.aiFuel)
			xmlFile:setBool(rootKey..".seeds", RDM_careerDefaults.aiSeeds)
			xmlFile:setBool(rootKey..".fertilizer", RDM_careerDefaults.aiFertilizer)
			xmlFile:setFloat(rootKey..".slurry", RDM_careerDefaults.aiSlurry)
			xmlFile:setFloat(rootKey..".manure", RDM_careerDefaults.aiManure)



            xmlFile:save()
            xmlFile:delete()
        end






	end

end

function RDM_careerDefaults:createSchema()

	RDM_careerDefaults.xmlSchema = XMLSchema.new("RDM_careerDefaults")

	local rootKey = "RDM_careerDefaults"
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".seasonalGrowth", "Set seasonal growth", RDM_careerDefaults.seasonalGrowth)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.FLOAT, rootKey..".daysPerPeriod", "Set seasonal growth", RDM_careerDefaults.daysPerPeriod)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".fixedVisualMonth", "Set seasonal growth", RDM_careerDefaults.fixedVisualMonth)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".snow", "Set seasonal growth", RDM_careerDefaults.snow)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".cropDestruction", "Set seasonal growth", RDM_careerDefaults.cropDestruction)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".ploughing", "Set seasonal growth", RDM_careerDefaults.ploughing)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".fieldStone", "Set seasonal growth", RDM_careerDefaults.fieldStone)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".weeds", "Set seasonal growth", RDM_careerDefaults.weeds)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".autoStart", "Set seasonal growth", RDM_careerDefaults.autoStart)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".stopBraking", "Set seasonal growth", RDM_careerDefaults.stopBraking)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".trailerFillLimit", "Set seasonal growth", RDM_careerDefaults.trailerFillLimit)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.FLOAT, rootKey..".dirt", "Set seasonal growth", RDM_careerDefaults.dirt)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.FLOAT, rootKey..".fuelUsage", "Set seasonal growth", RDM_careerDefaults.fuelUsage)
	rootKey = rootKey..".ai"
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".fuel", "Set seasonal growth", RDM_careerDefaults.aiFuel)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".seeds", "Set seasonal growth", RDM_careerDefaults.aiSeeds)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".fertilizer", "Set seasonal growth", RDM_careerDefaults.aiFertilizer)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".slurry", "Set seasonal growth", RDM_careerDefaults.aiSlurry)
	RDM_careerDefaults.xmlSchema:register(XMLValueType.BOOL, rootKey..".manure", "Set seasonal growth", RDM_careerDefaults.aiManure)

end






Environment.load = Utils.overwrittenFunction(Environment.load, 

function(self,superfunc,filename)
	self.xmlFilename = filename
	local xmlFile = XMLFile.load("Environment", filename)

	if xmlFile == nil then
		Logging.fatal("Could not load environment '%s'", filename)
	end

	local baseKey = "environment"
	--RDM Edits
	Environment.INITIAL_DAY = RDM_careerDefaults.initialDay
	self.daysPerPeriod = RDM_careerDefaults.daysPerPeriod
	self.plannedDaysPerPeriod = RDM_careerDefaults.daysPerPeriod
	
	
	self.currentDay = 1
	self.currentMonotonicDay = 1
	self.currentDayInPeriod = 1
	self.currentYear = 1
	self.currentDayInSeason = 1
	self.currentVisualDayInSeason = 1
	self.currentSeason = Environment.SEASON.SPRING
	self.currentPeriod = Environment.PERIOD.EARLY_SPRING
	
	self.timeAdjustment = 1 / self.daysPerPeriod
	
	self.currentVisualSeason = Environment.SEASON.SPRING
	self.currentVisualPeriod = Environment.PERIOD.EARLY_SPRING
	self.visualPeriodLocked = false
	self.dayLength = 86400000
	self.realHourLength = 3600000
	self.realHourTimer = self.realHourLength
	local ambientSoundModifiers = self.ambientSoundModifiers
	self.timeRanges = {
		night = self:addTimeRange(20, 5, ambientSoundModifiers.setIsNight),
		preSunrise = self:addTimeRange(5, 6, ambientSoundModifiers.setIsPreSunrise),
		sunrise = self:addTimeRange(6, 7, ambientSoundModifiers.setIsSunrise),
		postSunrise = self:addTimeRange(7, 8, ambientSoundModifiers.setIsPostSunrise),
		morning = self:addTimeRange(8, 11, ambientSoundModifiers.setIsMorning),
		preNoon = self:addTimeRange(11, 12, ambientSoundModifiers.setIsPreNoon),
		noon = self:addTimeRange(12, 13, ambientSoundModifiers.setIsNoon),
		postNoon = self:addTimeRange(13, 14, ambientSoundModifiers.setIsPostNoon),
		afternoon = self:addTimeRange(14, 17, ambientSoundModifiers.setIsAfternoon),
		preSunset = self:addTimeRange(17, 18, ambientSoundModifiers.setIsPreSunset),
		sunset = self:addTimeRange(18, 19, ambientSoundModifiers.setIsSunset),
		postSunset = self:addTimeRange(19, 20, ambientSoundModifiers.setIsPostSunset)
	}

	self.daylight:load(xmlFile, baseKey)
	self:updateJulianDay()

	local startHour = xmlFile:getFloat(baseKey .. "startHour", 8)
	local dayTime = 0

	if startHour ~= nil then
		dayTime = startHour * 60 * 60 * 1000
	end

	self:setEnvironmentTime(Environment.INITIAL_DAY, Environment.INITIAL_DAY, dayTime, self.daysPerPeriod, false)

	self.dayNightCycle = xmlFile:getBool(baseKey .. "#dayNightCycle", true)

	self.lighting:load(xmlFile, baseKey .. ".lighting")
	self.weather:setIsRainAllowed(true)
	self.weather:load(xmlFile, baseKey)
	ambientSoundModifiers.setIsSpring(self.currentVisualSeason == Environment.SEASON.SPRING)
	ambientSoundModifiers.setIsSummer(self.currentVisualSeason == Environment.SEASON.SUMMER)
	ambientSoundModifiers.setIsAutumn(self.currentVisualSeason == Environment.SEASON.AUTUMN)
	ambientSoundModifiers.setIsWinter(self.currentVisualSeason == Environment.SEASON.WINTER)
	self.environmentMaskSystem:setDayOfYear(Environment.PERIOD_DAY_MAPPING[self.currentVisualPeriod], self.currentVisualSeason)
	self.environmentMaskSystem:setIsSunOn(self.isSunOn)

	self.dayTimeScale = xmlFile:getFloat(baseKey .. "#dayTimeScale", 60)
	self.nightTimeScale = xmlFile:getFloat(baseKey .. "#nightTimeScale", 30)
	self.dirtColorDefault = xmlFile:getVector(baseKey .. ".dirtColors#default", {
		0.2,
		0.14,
		0.08
	}, 3)
	self.dirtColorSnow = xmlFile:getVector(baseKey .. ".dirtColors#snow", {
		0.95,
		0.95,
		0.95
	}, 3)
	self.depthOfField = xmlFile:getBool(baseKey .. "#depthOfField", true)

	g_depthOfFieldManager:setEnvironmentDoFEnabled(self.depthOfField)
	xmlFile:delete()
	g_messageCenter:unsubscribeAll(self)
	g_messageCenter:subscribe(MessageType.OWN_PLAYER_ENTERED, self.onPlayerEntered, self)
	g_messageCenter:subscribe(MessageType.OWN_PLAYER_LEFT, self.onPlayerLeft, self)

	return self
end



)


